/*******************************************************************************
 * FoxProjectile_ThrownBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxProjectile_ThrownBase extends FoxProjectile_GrenadeBase
    abstract
    native(Weapon)
    config(Projectile)
    hidecategories(Navigation);

var const int RandPitchRange;
var const int RandYawRange;
var const int RandRollRange;
var AkEvent StartLoopEvent;
var AkEvent StopLoopEvent;
var const Vector StickMeshOffset;
var bool bTurnOffCollision;

simulated event PostBeginPlay()
{
    super.PostBeginPlay();
    PlayAkEvent(StartLoopEvent, true);
    // End:0xF8
    if(((RandPitchRange > 0) || RandYawRange > 0) || RandRollRange > 0)
    {
        RotationRate.Pitch = Rand(RandPitchRange) - (RandPitchRange / 2);
        RotationRate.Yaw = Rand(RandYawRange) - (RandYawRange / 2);
        RotationRate.Roll = Rand(RandRollRange) - (RandRollRange / 2);
    }
    //return;    
}

simulated function StopBounce(Vector HitNormal, optional Vector HitLocation)
{
    bBounce = false;
    SetPhysics(0);
    //return;    
}

simulated function Bounce(Vector HitLocation, Vector HitNormal)
{
    RandSpin(100000.0);
    super.Bounce(HitLocation, HitNormal);
    //return;    
}

simulated event ParticleSystem GetImpactParticleSystem(PhysicalMaterial PhysMat)
{
    // End:0x196
    if(FoxGRI(WorldInfo.GRI).IsEffectRelevant(Instigator, Location, 4000.0, false, FoxGRI(WorldInfo.GRI).CheckEffectDistance_SpawnWithinCullDistance))
    {
        // End:0x196
        if((((PhysMat != none) && PhysMat.PhysicalMaterialProperty != none) && FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) != none) && FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).ImpactFX_Info != none)
        {
            return FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).ImpactFX_Info.ProjectileImpactFX;
        }
    }
    return none;
    //return ReturnValue;    
}

simulated function PlayImpactSound(PhysicalMaterial PhysMat)
{
    local AkEvent HitEvent;

    // End:0x19F
    if(FoxGRI(WorldInfo.GRI).IsEffectRelevant(Instigator, Location, 4000.0, false, FoxGRI(WorldInfo.GRI).CheckEffectDistance_SpawnWithinCullDistance))
    {
        // End:0x19F
        if((((PhysMat != none) && PhysMat.PhysicalMaterialProperty != none) && FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty) != none) && FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).ImpactFX_Info != none)
        {
            HitEvent = FoxPhysicalMaterialProperty(PhysMat.PhysicalMaterialProperty).ImpactFX_Info.ProjectileImpactSound;
        }
    }
    // End:0x1C6
    if(HitEvent != none)
    {
        PlayAkEvent(HitEvent, true, true, true);
    }
    //return;    
}

simulated event Destroyed()
{
    Mesh.DetachFromAny();
    // End:0x4D
    if(CollisionComponent != none)
    {
        CollisionComponent.DetachFromAny();
    }
    // End:0x7B
    if(TrailEmitterComponent != none)
    {
        TrailEmitterComponent.DetachFromAny();
    }
    PlayAkEvent(StopLoopEvent, true);
    super.Destroyed();
    //return;    
}

simulated function HandleStickTo(StickToDetails NewStickToInfo)
{
    SetMeshOffset();
    PlayAkEvent(StopLoopEvent, true);
    // End:0x69
    if(bTurnOffCollision)
    {
        SetCollision(false, false, true);
        // End:0x66
        if(CollisionComponent != none)
        {
            CollisionComponent.SetActorCollision(false, false);
        }
    }
    // End:0x8D
    else
    {
        SetOwner(none);
        ResizeCylinderComponent(10.0, 10.0);
        bCanBeDamaged = true;
    }
    TrailEmitterComponent.DeactivateSystem();
    super.HandleStickTo(NewStickToInfo);
    // End:0x107
    if(!NewStickToInfo.bStickToPawn)
    {
        DamageNearByProjectiles(NewStickToInfo.StickToLocation);
    }
    //return;    
}

// Export UFoxProjectile_ThrownBase::execDamageNearByProjectiles(FFrame&, void* const)
native function DamageNearByProjectiles(Vector StickLocation);

simulated function SetMeshOffset()
{
    Mesh.SetTranslation(StickMeshOffset);
    //return;    
}

defaultproperties
{
    bTurnOffCollision=true
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_ThrownBase.StaticMeshComponent0'
    Mesh=StaticMeshComponent0
    bSpotGrenade=false
    bStickToTarget=true
    bTraceStickToWorld=true
    bStickWithVelocityRotation=true
    bCanPickup=true
    GrenadeTimerLength=0.0
    GravityScale=0.30
    ProjLightEnvironment=DynamicLightEnvironmentComponent'Default__FoxProjectile_ThrownBase.MyLightEnvironment'
    Speed=5000.0
    MaxSpeed=5000.0
    Damage=1.0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_ThrownBase.CollisionCylinder'
    CylinderComponent=CollisionCylinder
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_ThrownBase.CollisionCylinder'
    Components(0)=CollisionCylinder
    Components(1)=DynamicLightEnvironmentComponent'Default__FoxProjectile_ThrownBase.MyLightEnvironment'
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
    object end
    // Reference: StaticMeshComponent'Default__FoxProjectile_ThrownBase.StaticMeshComponent0'
    Components(2)=StaticMeshComponent0
    LifeSpan=25.0
    begin object name=CollisionCylinder class=CylinderComponent
        ReplacementPrimitive=none
    object end
    // Reference: CylinderComponent'Default__FoxProjectile_ThrownBase.CollisionCylinder'
    CollisionComponent=CollisionCylinder
}